(function() {

    var DownHookUtil = {
        parseResourceUrl: function(text) {
            var pattern = /(?:ftp|https|http):\/\/[^"'?\/\s]+\/[^"'?\s]{0,4096}?\.(?:mp4|avi|rmvb|rm|3gp|3pg|flv|wmv|mkv|mpg|mov)(?:\?[^"\s]+)?/g;
            var result = pattern.exec(text)
            if (result != null) {
                return result[0];
            }
            pattern = /(thunder:\/\/[A-Za-z0-9\+/]+(?:=))|(magnet:\?xt=urn:btih:[A-Za-z0-9]{32,40})|(ed2k:\/\/\|file\|[^\/\|]+?\|[^\/\|]+?\|[^\/\|\"]+?\|(?:[^\s\/]+\|)?(?:\/?))*/g;
            var result = pattern.exec(text)
            if (result != null) {
                return result[0];
            }
            return null;
        },

        encodeToDownUrl: function(url) {
            return "thunderbrowser://xxxx.com/playicondown?down=" + encodeURIComponent(url) + "&ref=" + encodeURIComponent(document.location.href);
        },

        hookHref: function(e, url) {
            e.setAttribute("href", this.encodeToDownUrl(url));
        },

        findResourceUrlInTagA: function(array) {
            if (array != null) {
                for (var i = 0; i < array.length; i++) {
                    var element = array[i];
                    var u = element.getAttribute("href");
                    if (u != null) {
                        var url = this.parseResourceUrl(u);
                        if (url != null && url != undefined && url != "") {
                            return url;
                        }
                    }
                }
            }
            return null;
        },

        findResourceUrlInTagP: function(array) {
            if (array != null) {
                for (var i = 0; i < array.length; i++) {
                    var element = array[i];
                    var u = element.innerText;
                    if (u != null) {
                        var url = this.parseResourceUrl(u);
                        if (url != null && url != undefined && url != "") {
                            return url;
                        }
                    }
                }
            }
            return null;
        },

        searchResourceUrlInElements: function(elements) {
            var url = null;
            if (elements != null) {
                for (var i = 0; i < elements.length; i++) {
                    var items = elements[i].getElementsByTagName("a");
                    url = this.findResourceUrlInTagA(items);
                    if (url != null) {
                        return url;
                    }
                    items = elements[i].getElementsByTagName("p");
                    url = this.findResourceUrlInTagP(items);
                    if (url != null) {
                        return url;
                    }
                }
            }
            return url;
        }
    };

    function createHook() {
        function checkAndHookButton(element, url) {
            var names = ["播放", "手机版下载", "电脑版下载", "高清BT种子", "老司机种子", "旋风下载"];
            var title = element.getAttribute("title");
            if (title == null) {
                title = element.text;
            }
            if (title != null) {
                for (var i = 0; i < names.length; i++) {
                    var name = names[i];
                    if (title.indexOf(name) != -1) {
                        DownHookUtil.hookHref(element, url);
                    }
                }
            }
        };

        function checkAndHookPlayButtonInNodes(nodes, url) {
            if (nodes != null && nodes != undefined) {
                for (var i = 0; i < nodes.length; i++) {
                    var items = nodes[i].getElementsByTagName("a");
                    for (var index = 0; index < items.length; index++) {
                        checkAndHookButton(items[index], url);
                    }
                }
            }
        };
        var obj = {
            findResourceUrl: function() {
                return null;
            },

            hookWithUrl: function(url) {},

            checkAndHookPlayButtonInNodes: checkAndHookPlayButtonInNodes,

            doHook: function() {
                var u = this.findResourceUrl();
                if (u != null) {
                    this.hookWithUrl(u);
                }
            }
        };
        return obj;
    };

    function getHooks() {

        var Hook1 = createHook();
        Hook1.findResourceUrl = function() {
            var nodes = document.getElementsByClassName("downlist");
            if (nodes == null || nodes.length == 0) {
                nodes = document.getElementsByClassName("ndownlist");
            }
            return DownHookUtil.searchResourceUrlInElements(nodes);
        };
        Hook1.hookWithUrl = function(url) {
            try {
                var nodes = document.getElementsByClassName("play-list");
                this.checkAndHookPlayButtonInNodes(nodes, url);
            } catch (error) {
                /*  */
            }
        };

        var Hook2 = createHook();
        Hook2.findResourceUrl = function() {
            var nodes = document.getElementsByClassName("downurl");
            return DownHookUtil.searchResourceUrlInElements(nodes);
        };
        Hook2.hookWithUrl = function(url) {
            try {
                this.checkAndHookPlayButtonInNodes(document.getElementsByClassName("film_bar clear_fix"), url);
                this.checkAndHookPlayButtonInNodes(document.getElementsByClassName("film_bar clearfix"), url);
            } catch (error) {
                /*  */
            }
        };

        var Hook3 = createHook();
        Hook3.findResourceUrl = function() {
            var nodes = document.getElementsByClassName("play-list");
            return DownHookUtil.searchResourceUrlInElements(nodes);
        };
        Hook3.hookWithUrl = function(url) {
            try {
                this.checkAndHookPlayButtonInNodes(document.getElementsByClassName("play-list"), url);
            } catch (error) {
                /*  */
            }
        };

        return new Array(Hook1, Hook2, Hook3);
    };


    var hooks = getHooks();
    if (hooks != null) {
        for (var i = 0; i < hooks.length; i++) {
            hooks[i].doHook();
        }
    }

})();